package awais.instagrabber;

import android.app.NotificationManager;
import android.content.ClipboardManager;
import android.content.Context;

import androidx.multidex.MultiDexApplication;

import java.net.CookieHandler;

import awais.instagrabber.utils.Utils;

import static awais.instagrabber.utils.Utils.clipboardManager;
import static awais.instagrabber.utils.Utils.notificationManager;
import static awais.instagrabber.utils.Utils.sharedPreferences;

public final class InstaApp extends MultiDexApplication {
    @Override
    public void onCreate() {
        super.onCreate();

        CookieHandler.setDefault(Utils.NET_COOKIE_MANAGER);

        Utils.isInstagramInstalled = Utils.isInstaInstalled(this);

        if (sharedPreferences == null)
            sharedPreferences = getSharedPreferences("settings", MODE_PRIVATE);
        if (notificationManager == null)
            notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
        if (clipboardManager == null)
            clipboardManager = (ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
    }
}