package awais.instagrabber.activities;

import android.annotation.SuppressLint;
import android.graphics.Bitmap;
import android.os.Build;
import android.os.Bundle;
import android.view.View;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import awais.instagrabber.R;
import awais.instagrabber.utils.Utils;

public class Login extends AppCompatActivity {
    private String webViewUrl;
    Button btnCookies, btnRefresh;
    WebView webView;

    @Override
    protected void onCreate(@Nullable final Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        webView = findViewById(R.id.webView);
        btnCookies = findViewById(R.id.cookies);
        btnRefresh = findViewById(R.id.refresh);

        initWebView();

        final View.OnClickListener onClickListener = v -> {
            if (v == btnRefresh) {
                if (webView != null) webView.loadUrl("https://instagram.com/");
            } else {
                final String mainCookie = Utils.getCookie(webViewUrl);
                if (Utils.isEmpty(mainCookie))
                    Toast.makeText(this, "Error loading cookies", Toast.LENGTH_SHORT).show();
                else {
                    Utils.setupCookies(mainCookie);
                    Utils.sharedPreferences.edit().putString("cookie", mainCookie).apply();
                    Toast.makeText(this, "Successfully loaded cookies!\nIf you still can't open private pages/posts, re-login!", Toast.LENGTH_SHORT).show();
                    finish();
                }
            }
        };

        btnRefresh.setOnClickListener(onClickListener);
        btnCookies.setOnClickListener(onClickListener);
    }

    @SuppressLint("SetJavaScriptEnabled")
    private void initWebView() {
        if (webView != null) {
            webView.setWebChromeClient(new WebChromeClient());
            webView.setWebViewClient(new WebViewClient() {
                @Override
                public void onPageStarted(final WebView view, final String url, final Bitmap favicon) {
                    webViewUrl = url;
                }

                @Override
                public void onPageFinished(final WebView view, final String url) {
                    webViewUrl = url;
                }
            });
            final WebSettings webSettings = webView.getSettings();
            if (webSettings != null) {
                webSettings.setJavaScriptEnabled(true);
                webSettings.setDomStorageEnabled(true);
                webSettings.setSupportZoom(true);
                webSettings.setBuiltInZoomControls(true);
                webSettings.setDisplayZoomControls(false);
                webSettings.setLoadWithOverviewMode(true);
                webSettings.setUseWideViewPort(true);
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN) {
                    webSettings.setAllowFileAccessFromFileURLs(true);
                    webSettings.setAllowUniversalAccessFromFileURLs(true);
                }
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP)
                    webSettings.setMixedContentMode(WebSettings.MIXED_CONTENT_ALWAYS_ALLOW);
            }

            webView.loadUrl("https://instagram.com/");
        }
    }
}