package awais.instagrabber.adapters;

import android.content.Context;
import android.database.Cursor;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.cursoradapter.widget.CursorAdapter;

import com.squareup.picasso.MemoryPolicy;

import awais.instagrabber.R;
import awais.instagrabber.utils.Utils;

public class SuggestionsAdapter extends CursorAdapter {
    private final LayoutInflater layoutInflater;
    private final View.OnClickListener onClickListener;

    public SuggestionsAdapter(final Context context, final View.OnClickListener onClickListener) {
        super(context, null, FLAG_REGISTER_CONTENT_OBSERVER);
        this.layoutInflater = LayoutInflater.from(context);
        this.onClickListener = onClickListener;
    }

    @Override
    public View newView(final Context context, final Cursor cursor, final ViewGroup parent) {
        return layoutInflater.inflate(R.layout.suggestion_item, parent, false);
    }

    @Override
    public void bindView(@NonNull final View view, final Context context, @NonNull final Cursor cursor) {
        String username = cursor.getString(1);
        username = cursor.getString(2).equals("TYPE_HASHTAG") ? '#' + username : username;

        view.setOnClickListener(onClickListener);
        view.setTag(username);

        final TextView tvFullName = view.findViewById(R.id.tvFullName);
        final ImageView pfp = view.findViewById(R.id.followPfp);
        view.findViewById(R.id.isVerified).setVisibility(cursor.getString(4).equals("false") ? View.GONE : View.VISIBLE);

        Utils.PICASSO.load(cursor.getString(3)).memoryPolicy(MemoryPolicy.NO_CACHE, MemoryPolicy.NO_STORE).into(pfp);
        tvFullName.setText(username);
    }
}
