package awais.instagrabber.asyncs;

import android.os.AsyncTask;
import android.util.Log;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import awais.instagrabber.interfaces.FetchListener;

public class ProfilePictureFetcher extends AsyncTask<Void, Void, String> {
    private final FetchListener<String> fetchListener;
    private final String userName;
    private final boolean alternativeMethod;

    public ProfilePictureFetcher(final String userName, final FetchListener<String> fetchListener, final boolean altMethod) {
        this.fetchListener = fetchListener;
        this.userName = userName;
        this.alternativeMethod = altMethod;
    }

    @Override
    protected String doInBackground(final Void... voids) {
        try {
            final String url = (alternativeMethod ? "https://instadphd.com/user/" :
                    "https://insta-stalkerr.com/instadp_fullsize/?id=") + userName;

            final Document doc = Jsoup.connect(url).get();
            final Elements imgs = doc.getElementsByTag("img");
            for (final Element img : imgs) {
                final String imgStr = img.toString();
                if (imgStr.contains("instagram.com") && (imgStr.contains("large_image") || imgStr.contains("img-responsive"))) {
                    return img.attr("src");
                }
            }

        } catch (Exception e) {
            Log.e("AWAISKING_APP", "", e);
        }

        return null;
    }

    @Override
    protected void onPreExecute() {
        if (fetchListener != null) fetchListener.doBefore();
    }

    @Override
    protected void onPostExecute(final String result) {
        if (fetchListener != null) fetchListener.onResult(result);
    }
}
