package awais.instagrabber.models;

public final class PostModel extends BasePostModel {
    protected final String thumbnailUrl;
    protected String endCursor;
    protected boolean hasNextPage, isSelected, isSlider;
    protected int position;

    public PostModel(final boolean isVideo, final String postId, final String displayUrl, final String thumbnailUrl,
                     final String shortCode, final String postCaption, long timestamp) {
        this.isVideo = isVideo;
        this.postId = postId;
        this.displayUrl = displayUrl;
        this.thumbnailUrl = thumbnailUrl;
        this.shortCode = shortCode;
        this.postCaption = postCaption;
        this.timestamp = timestamp;
    }

    public String getThumbnailUrl() {
        return thumbnailUrl;
    }

    public String getEndCursor() {
        return endCursor;
    }

    public int getPosition() {
        return position;
    }

    public boolean isSelected() {
        return isSelected;
    }

    public boolean isSlider() {
        return isSlider;
    }

    public boolean hasNextPage() {
        return endCursor != null && hasNextPage;
    }

    public void setPostId(final String postId) {
        this.postId = postId;
    }

    public void setPostCaption(final String postCaption) {
        this.postCaption = postCaption;
    }

    public void setTimestamp(final long timestamp) {
        this.timestamp = timestamp;
    }

    public void setPosition(final int position) {
        this.position = position;
    }

    public void setSelected(final boolean selected) {
        this.isSelected = selected;
    }

    public void setSlider(final boolean slider) {
        isSlider = slider;
    }

    public void setPageCursor(final boolean hasNextPage, final String endCursor) {
        this.endCursor = endCursor;
        this.hasNextPage = hasNextPage;
    }
}